/*
 * Copyright (C) LEE Ventus - All Rights Reserved
 * Unauthorised copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */
#ifndef CONTROLMETHODS_H
#define CONTROLMETHODS_H

#include <stdbool.h>
#include "controlMethods.h"

typedef struct
{
    float (*getInputValue)(void);
    float (*getSetPoint)(void);

    float proportionalTerm;
    float integralTerm;
    float integralMin;
    float integralMax;
    float differentialTerm; 
} controlMethods_pidSettings;

typedef struct
{
    float (*getInputValue)(void);

    float lowerThresh;
    float upperThresh;

    float lowerControlValue;
    float upperControlValue;
} controlMethods_bangBangSettings;


void controlMethods_startPID(controlMethods_pidSettings pidSettings,
                             bool resetITermAccumulator);

void controlMethods_startBangBang(controlMethods_bangBangSettings bbSettings);

// Tick the control method, returns the control value
float controlMethods_tick();


#endif // CONTROLMETHODS_H
