/*
 * Copyright (C) LEE Ventus - All Rights Reserved
 * Unauthorised copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */


#include "LEDValueGenerator.h"

//level is power in mw
//generates the pwm values for 14 leds
void generateGaugeLedValues(uint16_t level, uint8_t * outputBuffer)
{
    static const uint8_t ledLookup[100] =
                        { 0, 0, 0, 0, 0, 1, 1, 1, 1, 2,
                          2, 2, 3, 3, 4, 5, 5, 6, 7, 7,
                          8, 9, 10, 11, 12, 13, 14, 15, 17, 18,
                          19, 21, 22, 24, 25, 27, 29, 30, 32, 34,
                          36, 38, 40, 42, 44, 46, 48, 51, 53, 55,
                          58, 60, 63, 66, 68, 71, 74, 77, 80, 83,
                          86, 89, 92, 96, 99, 102, 106, 109, 113, 116,
                          120, 124, 128, 131, 135, 139, 143, 148, 152, 156,
                          160, 165, 169, 174, 178, 183, 188, 192, 197, 202,
                          207, 212, 217, 223, 228, 233, 238, 244, 249, 255 };

    if(level > 1400)
        level = 1400;

    //Set all LEDs that are 100% on
    for(int i=0; i<1 + (level/100); i++)
    	outputBuffer[i] = 255;

    //Set last on LED, to faded value
    outputBuffer[(level/100)] = ledLookup[level % 100];

    //Turn off other LEDs
    for(int i=1+(level/100); i<14; i++)
    	outputBuffer[i] = 0;
}
