/*
 * Copyright (C) LEE Ventus - All Rights Reserved
 * Unauthorised copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */

#ifndef I2CLP5861GAUGEHANDLER_H_
#define I2CLP5861GAUGEHANDLER_H_

#include "i2cMasterHandler.h"

#define LP5861_I2C_BASE_ADDRESS (0b1001000) //base 100 addr pins 10 registers 00
#define LP5861_I2C_BRIGHTNESS_ADDRESS (0b1001010) //base 100 addr pins 10 registers 10

#define LP5861_BRIGHTNESS_INITIAL_DELAY (50) //some time for the base setup to complete before we start writing led brightnesses


typedef enum
{
    RGB_LED_READY,
	RGB_LED_RUNNING,
	RGB_LED_ERROR
} rgb_led_state;

i2c_device LP5861_getDevice();
i2c_device LP5861BrigthnessControl_getDevice();

void LP5861_setGaugemW(uint16_t milliwatts);

void LP5861_setLEDColour(uint16_t RGB_value);

void LP5861_led_setState(rgb_led_state state);

void LP5861_tick();

#endif /* I2CLP5861GAUGEHANDLER_H_ */
