/*
 * Copyright (C) LEE Ventus - All Rights Reserved
 * Unauthorised copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */
#ifndef FASTATAN2_H
#define FASTATAN2_H

/*
 * atan2f is really slow on an arm M0+, too slow for regular use
 * in phaseDetector. Here is a fast version, which gets within 1 degree
 * of the true value. 
 * 
 * Basically an implementation of one of the answers here:
 * https://math.stackexchange.com/questions/1098487/atan2-faster-approximation/1105038
 */


#include <stdint.h>

float fastATan2(float x, float y);

#endif // FASTATAN2_H
