/*
 * Copyright (C) LEE Ventus - All Rights Reserved
 * Unauthorised copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */
#ifndef SAMPLING_H
#define SAMPLING_H

#include <stdint.h>

typedef struct sampling_channelConfig
{
    uint8_t oversamplingFactor;
    int16_t scalingMulti;
    uint8_t scalingRightShift;
} sampling_channelConfig;

// Each channel will be oversampled by 2^channelOversamplingFactor
void sampling_setup(uint8_t channelCount, 
                    sampling_channelConfig* channelConfigs);

void sampling_updateChannel(uint8_t channelId, int32_t newValue);

int32_t sampling_getChannelFiltered(uint8_t channelId);

int32_t sampling_getChannelRaw(uint8_t channelId);

#endif // SAMPLING_H
