/*
 * Copyright (C) LEE Ventus - All Rights Reserved
 * Unauthorised copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */
#ifndef SINEWAVEGEN_H
#define SINEWAVEGEN_H

#include <stdint.h>

typedef struct sineWaveGen_sample
{
    uint8_t highA;
    uint8_t highB;
    uint8_t lowB;
    uint8_t lowA;
} sineWaveGen_sample;

void sineWaveGen_getBlock(sineWaveGen_sample* samples, 
                          uint8_t sampleCount);

void sineWaveGen_setFrequencyHz(uint16_t freqHz);

void sineWaveGen_init(uint8_t timerPeriod, 
                      uint8_t deadTime, 
                      uint32_t sampleRateHz);

#endif // SINEWAVEGEN_H
