/*
 * Copyright (C) LEE Ventus - All Rights Reserved
 * Unauthorised copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */

#ifndef SETTINGS_STORAGE_H
#define SETTINGS_STORAGE_H

//We only need one page (256 bytes) of flash to store the settings
//Reserved 2k page in flash
#define SETTINGS_STORAGE_FLASH_PAGE_ADDRESS 0x800F800
#define SETTINGS_STORAGE_FLASH_PAGE 31

//Stored at the end of the settings array, 
//to indicate settings have been written
#define SETTINGS_STORAGE_FLASH_VALID_CODE 0xDEADBEEF

void settingsStorage_SaveCurrentSettings();

void settingsStorage_RestoreSavedSettings();

#endif
